diff --git a/contrib/ntp/ntpd/ntp_parser.c b/contrib/ntp/ntpd/ntp_parser.c
index 834b1fbd1acc..e5ee5e10a459 100644
--- a/contrib/ntp/ntpd/ntp_parser.c
+++ b/contrib/ntp/ntpd/ntp_parser.c
@@ -1932,28 +1920,28 @@ static const yytype_int8 yyr2[] =
        2,     2,     3,     2,     1,     1,     1,     1,     1,     1,
        1,     1,     1,     0,     2,     2,     2,     1,     1,     1,
        1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
-       2,     2,     4,     6,     4,     5,     5,     4,     0,     2,
-       0,     2,     3,     1,     1,     1,     1,     1,     1,     1,
+       2,     2,     5,     4,     5,     5,     4,     3,     3,     0,
+       2,     0,     2,     0,     2,     3,     1,     1,     1,     1,
        1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
-       2,     1,     2,     1,     1,     1,     2,     1,     2,     1,
-       1,     1,     1,     1,     1,     1,     1,     3,     2,     1,
-       2,     2,     2,     2,     2,     1,     1,     1,     1,     1,
-       1,     1,     3,     2,     1,     2,     1,     1,     2,     2,
-       1,     2,     1,     1,     1,     2,     2,     2,     1,     1,
+       1,     1,     1,     2,     1,     2,     1,     1,     1,     2,
+       1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
+       3,     2,     1,     2,     2,     2,     2,     2,     1,     1,
+       1,     1,     1,     1,     1,     3,     2,     1,     2,     1,
+       1,     2,     2,     1,     2,     1,     1,     1,     2,     2,
+       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
+       1,     1,     1,     1,     1,     1,     2,     2,     1,     2,
        1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
-       1,     1,     1,     2,     2,     1,     2,     1,     1,     1,
-       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
-       2,     2,     2,     3,     3,     1,     2,     2,     2,     2,
-       2,     3,     2,     1,     1,     1,     1,     1,     1,     1,
-       0,     1,     1,     1,     1,     1,     2,     0,     0,     2,
-       4,     1,     1,     4,     1,     0,     0,     2,     2,     2,
-       2,     1,     1,     3,     3,     1,     1,     1,     1,     1,
-       1,     1,     1,     1,     2,     2,     1,     1,     1,     1,
-       1,     1,     1,     1,     2,     1,     2,     1,     1,     1,
-       5,     2,     1,     2,     1,     1,     1,     1,     1,     1,
-       2,     5,     1,     3,     2,     3,     1,     1,     2,     1,
-       5,     4,     3,     2,     1,     6,     3,     2,     3,     1,
-       1,     1,     1,     1
+       1,     1,     2,     2,     2,     2,     3,     3,     1,     2,
+       2,     2,     2,     2,     3,     2,     1,     1,     1,     1,
+       1,     1,     1,     0,     1,     1,     1,     1,     1,     2,
+       0,     0,     2,     4,     1,     1,     4,     1,     0,     0,
+       2,     2,     2,     2,     1,     1,     3,     3,     1,     1,
+       1,     1,     1,     1,     1,     1,     1,     2,     2,     1,
+       1,     1,     1,     1,     1,     1,     1,     2,     1,     2,
+       1,     1,     1,     5,     2,     1,     2,     1,     1,     1,
+       1,     1,     1,     2,     5,     1,     3,     2,     3,     1,
+       1,     2,     1,     5,     4,     3,     2,     1,     6,     3,
+       2,     3,     1,     1,     1,     1,     1
 };
 
 
@@ -1965,6 +1953,7 @@ enum { YYENOMEM = -2 };
 #define YYACCEPT        goto yyacceptlab
 #define YYABORT         goto yyabortlab
 #define YYERROR         goto yyerrorlab
+#define YYNOMEM         goto yyexhaustedlab
 
 
 #define YYRECOVERING()  (!!yyerrstatus)
@@ -2005,10 +1994,7 @@ do {                                            \
     YYFPRINTF Args;                             \
 } while (0)
 
-/* This macro is provided for backward compatibility. */
-# ifndef YY_LOCATION_PRINT
-#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
-# endif
+
 
 
 # define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
@@ -2035,10 +2021,6 @@ yy_symbol_value_print (FILE *yyo,
   YY_USE (yyoutput);
   if (!yyvaluep)
     return;
-# ifdef YYPRINT
-  if (yykind < YYNTOKENS)
-    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
-# endif
   YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
   YY_USE (yykind);
   YY_IGNORE_MAYBE_UNINITIALIZED_END
@@ -2223,6 +2205,7 @@ yyparse (void)
   YYDPRINTF ((stderr, "Starting parse\n"));
 
   yychar = YYEMPTY; /* Cause a token to be read.  */
+
   goto yysetstate;
 
 
@@ -2248,7 +2231,7 @@ yyparse (void)
 
   if (yyss + yystacksize - 1 <= yyssp)
 #if !defined yyoverflow && !defined YYSTACK_RELOCATE
-    goto yyexhaustedlab;
+    YYNOMEM;
 #else
     {
       /* Get the current used size of the three stacks, in elements.  */
@@ -2276,7 +2259,7 @@ yyparse (void)
 # else /* defined YYSTACK_RELOCATE */
       /* Extend the stack our own way.  */
       if (YYMAXDEPTH <= yystacksize)
-        goto yyexhaustedlab;
+        YYNOMEM;
       yystacksize *= 2;
       if (YYMAXDEPTH < yystacksize)
         yystacksize = YYMAXDEPTH;
@@ -2287,7 +2270,7 @@ yyparse (void)
           YY_CAST (union yyalloc *,
                    YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
         if (! yyptr)
-          goto yyexhaustedlab;
+          YYNOMEM;
         YYSTACK_RELOCATE (yyss_alloc, yyss);
         YYSTACK_RELOCATE (yyvs_alloc, yyvs);
 #  undef YYSTACK_RELOCATE
@@ -2309,6 +2292,7 @@ yyparse (void)
     }
 #endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */
 
+
   if (yystate == YYFINAL)
     YYACCEPT;
 
@@ -2421,7 +2405,7 @@ yyparse (void)
   switch (yyn)
     {
   case 5: /* command_list: error T_EOC  */
-#line 404 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 406 "../../ntpd/ntp_parser.y"
                 {
 			/* I will need to incorporate much more fine grained
 			 * error messages. The following should suffice for
@@ -2434,85 +2418,85 @@ yyparse (void)
 				ip_ctx->errpos.nline,
 				ip_ctx->errpos.ncol);
 		}
-#line 2438 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2422 "ntp_parser.c"
     break;
 
   case 21: /* server_command: client_type address option_list  */
-#line 441 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 443 "../../ntpd/ntp_parser.y"
                 {
 			peer_node *my_node;
 
 			my_node = create_peer_node((yyvsp[-2].Integer), (yyvsp[-1].Address_node), (yyvsp[0].Attr_val_fifo));
 			APPEND_G_FIFO(cfgt.peers, my_node);
 		}
-#line 2449 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2433 "ntp_parser.c"
     break;
 
   case 28: /* address: address_fam T_String  */
-#line 460 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 462 "../../ntpd/ntp_parser.y"
                         { (yyval.Address_node) = create_address_node((yyvsp[0].String), (yyvsp[-1].Integer)); }
-#line 2455 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2439 "ntp_parser.c"
     break;
 
   case 29: /* ip_address: T_String  */
-#line 465 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 467 "../../ntpd/ntp_parser.y"
                         { (yyval.Address_node) = create_address_node((yyvsp[0].String), AF_UNSPEC); }
-#line 2461 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2445 "ntp_parser.c"
     break;
 
   case 30: /* address_fam: T_Ipv4_flag  */
-#line 470 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 472 "../../ntpd/ntp_parser.y"
                         { (yyval.Integer) = AF_INET; }
-#line 2467 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2451 "ntp_parser.c"
     break;
 
   case 31: /* address_fam: T_Ipv6_flag  */
-#line 472 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 474 "../../ntpd/ntp_parser.y"
                         { (yyval.Integer) = AF_INET6; }
-#line 2473 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2457 "ntp_parser.c"
     break;
 
   case 32: /* option_list: %empty  */
-#line 477 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 479 "../../ntpd/ntp_parser.y"
                         { (yyval.Attr_val_fifo) = NULL; }
-#line 2479 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2463 "ntp_parser.c"
     break;
 
   case 33: /* option_list: option_list option  */
-#line 479 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 481 "../../ntpd/ntp_parser.y"
                 {
 			(yyval.Attr_val_fifo) = (yyvsp[-1].Attr_val_fifo);
 			APPEND_G_FIFO((yyval.Attr_val_fifo), (yyvsp[0].Attr_val));
 		}
-#line 2488 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2472 "ntp_parser.c"
     break;
 
   case 37: /* option_flag: option_flag_keyword  */
-#line 493 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 495 "../../ntpd/ntp_parser.y"
                         { (yyval.Attr_val) = create_attr_ival(T_Flag, (yyvsp[0].Integer)); }
-#line 2494 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2478 "ntp_parser.c"
     break;
 
   case 47: /* option_int: option_int_keyword T_Integer  */
-#line 510 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 512 "../../ntpd/ntp_parser.y"
                         { (yyval.Attr_val) = create_attr_ival((yyvsp[-1].Integer), (yyvsp[0].Integer)); }
-#line 2500 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2484 "ntp_parser.c"
     break;
 
   case 48: /* option_int: option_int_keyword T_U_int  */
-#line 512 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 514 "../../ntpd/ntp_parser.y"
                         { (yyval.Attr_val) = create_attr_uval((yyvsp[-1].Integer), (yyvsp[0].Integer)); }
-#line 2506 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2490 "ntp_parser.c"
     break;
 
   case 55: /* option_str: option_str_keyword T_String  */
-#line 526 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 528 "../../ntpd/ntp_parser.y"
                         { (yyval.Attr_val) = create_attr_sval((yyvsp[-1].Integer), (yyvsp[0].String)); }
-#line 2512 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2496 "ntp_parser.c"
     break;
 
   case 57: /* unpeer_command: unpeer_keyword address  */
-#line 540 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 542 "../../ntpd/ntp_parser.y"
                 {
 			unpeer_node *my_node;
 
@@ -2520,85 +2504,85 @@ yyparse (void)
 			if (my_node)
 				APPEND_G_FIFO(cfgt.unpeers, my_node);
 		}
-#line 2524 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2508 "ntp_parser.c"
     break;
 
   case 60: /* other_mode_command: T_Broadcastclient  */
-#line 561 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 563 "../../ntpd/ntp_parser.y"
                         { cfgt.broadcastclient = 1; }
-#line 2530 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2514 "ntp_parser.c"
     break;
 
   case 61: /* other_mode_command: T_Manycastserver address_list  */
-#line 563 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 565 "../../ntpd/ntp_parser.y"
                         { CONCAT_G_FIFOS(cfgt.manycastserver, (yyvsp[0].Address_fifo)); }
-#line 2536 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2520 "ntp_parser.c"
     break;
 
   case 62: /* other_mode_command: T_Multicastclient address_list  */
-#line 565 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 567 "../../ntpd/ntp_parser.y"
                         { CONCAT_G_FIFOS(cfgt.multicastclient, (yyvsp[0].Address_fifo)); }
-#line 2542 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2526 "ntp_parser.c"
     break;
 
   case 63: /* other_mode_command: T_Mdnstries T_Integer  */
-#line 567 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 569 "../../ntpd/ntp_parser.y"
                         { cfgt.mdnstries = (yyvsp[0].Integer); }
-#line 2548 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2532 "ntp_parser.c"
     break;
 
   case 64: /* authentication_command: T_Automax T_Integer  */
-#line 578 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 580 "../../ntpd/ntp_parser.y"
                 {
 			attr_val *atrv;
 
 			atrv = create_attr_ival((yyvsp[-1].Integer), (yyvsp[0].Integer));
 			APPEND_G_FIFO(cfgt.vars, atrv);
 		}
-#line 2559 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2543 "ntp_parser.c"
     break;
 
   case 65: /* authentication_command: T_ControlKey T_Integer  */
-#line 585 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 587 "../../ntpd/ntp_parser.y"
                         { cfgt.auth.control_key = (yyvsp[0].Integer); }
-#line 2565 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2549 "ntp_parser.c"
     break;
 
   case 66: /* authentication_command: T_Crypto crypto_command_list  */
-#line 587 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 589 "../../ntpd/ntp_parser.y"
                 {
 			cfgt.auth.cryptosw++;
 			CONCAT_G_FIFOS(cfgt.auth.crypto_cmd_list, (yyvsp[0].Attr_val_fifo));
 		}
-#line 2574 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2558 "ntp_parser.c"
     break;
 
   case 67: /* authentication_command: T_Keys T_String  */
-#line 592 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 594 "../../ntpd/ntp_parser.y"
                         { cfgt.auth.keys = (yyvsp[0].String); }
-#line 2580 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2564 "ntp_parser.c"
     break;
 
   case 68: /* authentication_command: T_Keysdir T_String  */
-#line 594 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 596 "../../ntpd/ntp_parser.y"
                         { cfgt.auth.keysdir = (yyvsp[0].String); }
-#line 2586 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2570 "ntp_parser.c"
     break;
 
   case 69: /* authentication_command: T_Requestkey T_Integer  */
-#line 596 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 598 "../../ntpd/ntp_parser.y"
                         { cfgt.auth.request_key = (yyvsp[0].Integer); }
-#line 2592 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2576 "ntp_parser.c"
     break;
 
   case 70: /* authentication_command: T_Revoke T_Integer  */
-#line 598 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 600 "../../ntpd/ntp_parser.y"
                         { cfgt.auth.revoke = (yyvsp[0].Integer); }
-#line 2598 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2582 "ntp_parser.c"
     break;
 
   case 71: /* authentication_command: T_Trustedkey integer_list_range  */
-#line 600 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 602 "../../ntpd/ntp_parser.y"
                 {
 			/* [Bug 948] leaves it open if appending or
 			 * replacing the trusted key list is the right
@@ -2608,38 +2592,38 @@ yyparse (void)
 			DESTROY_G_FIFO(cfgt.auth.trusted_key_list, destroy_attr_val); /* remove for append */
 			CONCAT_G_FIFOS(cfgt.auth.trusted_key_list, (yyvsp[0].Attr_val_fifo));
 		}
-#line 2612 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2596 "ntp_parser.c"
     break;
 
   case 72: /* authentication_command: T_NtpSignDsocket T_String  */
-#line 610 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 612 "../../ntpd/ntp_parser.y"
                         { cfgt.auth.ntp_signd_socket = (yyvsp[0].String); }
-#line 2618 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2602 "ntp_parser.c"
     break;
 
   case 73: /* crypto_command_list: %empty  */
-#line 615 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 617 "../../ntpd/ntp_parser.y"
                         { (yyval.Attr_val_fifo) = NULL; }
-#line 2624 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2608 "ntp_parser.c"
     break;
 
   case 74: /* crypto_command_list: crypto_command_list crypto_command  */
-#line 617 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 619 "../../ntpd/ntp_parser.y"
                 {
 			(yyval.Attr_val_fifo) = (yyvsp[-1].Attr_val_fifo);
 			APPEND_G_FIFO((yyval.Attr_val_fifo), (yyvsp[0].Attr_val));
 		}
-#line 2633 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2617 "ntp_parser.c"
     break;
 
   case 75: /* crypto_command: crypto_str_keyword T_String  */
-#line 625 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 627 "../../ntpd/ntp_parser.y"
                         { (yyval.Attr_val) = create_attr_sval((yyvsp[-1].Integer), (yyvsp[0].String)); }
-#line 2639 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2623 "ntp_parser.c"
     break;
 
   case 76: /* crypto_command: T_Revoke T_Integer  */
-#line 627 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 629 "../../ntpd/ntp_parser.y"
                 {
 			(yyval.Attr_val) = NULL;
 			cfgt.auth.revoke = (yyvsp[0].Integer);
@@ -2648,65 +2632,65 @@ yyparse (void)
 				"please use 'revoke %d' instead.",
 				cfgt.auth.revoke, cfgt.auth.revoke);
 		}
-#line 2652 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2636 "ntp_parser.c"
     break;
 
   case 82: /* orphan_mode_command: T_Tos tos_option_list  */
-#line 652 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 654 "../../ntpd/ntp_parser.y"
                         { CONCAT_G_FIFOS(cfgt.orphan_cmds, (yyvsp[0].Attr_val_fifo)); }
-#line 2658 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2642 "ntp_parser.c"
     break;
 
   case 83: /* tos_option_list: tos_option_list tos_option  */
-#line 657 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 659 "../../ntpd/ntp_parser.y"
                 {
 			(yyval.Attr_val_fifo) = (yyvsp[-1].Attr_val_fifo);
 			APPEND_G_FIFO((yyval.Attr_val_fifo), (yyvsp[0].Attr_val));
 		}
-#line 2667 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2651 "ntp_parser.c"
     break;
 
   case 84: /* tos_option_list: tos_option  */
-#line 662 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 664 "../../ntpd/ntp_parser.y"
                 {
 			(yyval.Attr_val_fifo) = NULL;
 			APPEND_G_FIFO((yyval.Attr_val_fifo), (yyvsp[0].Attr_val));
 		}
-#line 2676 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2660 "ntp_parser.c"
     break;
 
   case 85: /* tos_option: tos_option_int_keyword T_Integer  */
-#line 670 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 672 "../../ntpd/ntp_parser.y"
                         { (yyval.Attr_val) = create_attr_dval((yyvsp[-1].Integer), (double)(yyvsp[0].Integer)); }
-#line 2682 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2666 "ntp_parser.c"
     break;
 
   case 86: /* tos_option: tos_option_dbl_keyword number  */
-#line 672 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 674 "../../ntpd/ntp_parser.y"
                         { (yyval.Attr_val) = create_attr_dval((yyvsp[-1].Integer), (yyvsp[0].Double)); }
-#line 2688 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2672 "ntp_parser.c"
     break;
 
   case 87: /* tos_option: T_Cohort boolean  */
-#line 674 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 676 "../../ntpd/ntp_parser.y"
                         { (yyval.Attr_val) = create_attr_dval((yyvsp[-1].Integer), (double)(yyvsp[0].Integer)); }
-#line 2694 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2678 "ntp_parser.c"
     break;
 
   case 88: /* tos_option: basedate  */
-#line 676 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 678 "../../ntpd/ntp_parser.y"
                         { (yyval.Attr_val) = create_attr_ival(T_Basedate, (yyvsp[0].Integer)); }
-#line 2700 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2684 "ntp_parser.c"
     break;
 
   case 100: /* monitoring_command: T_Statistics stats_list  */
-#line 703 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 705 "../../ntpd/ntp_parser.y"
                         { CONCAT_G_FIFOS(cfgt.stats_list, (yyvsp[0].Int_fifo)); }
-#line 2706 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2690 "ntp_parser.c"
     break;
 
   case 101: /* monitoring_command: T_Statsdir T_String  */
-#line 705 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 707 "../../ntpd/ntp_parser.y"
                 {
 			if (lex_from_file()) {
 				cfgt.stats_dir = (yyvsp[0].String);
@@ -2715,55 +2699,55 @@ yyparse (void)
 				yyerror("statsdir remote configuration ignored");
 			}
 		}
-#line 2719 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2703 "ntp_parser.c"
     break;
 
   case 102: /* monitoring_command: T_Filegen stat filegen_option_list  */
-#line 714 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 716 "../../ntpd/ntp_parser.y"
                 {
 			filegen_node *fgn;
 
 			fgn = create_filegen_node((yyvsp[-1].Integer), (yyvsp[0].Attr_val_fifo));
 			APPEND_G_FIFO(cfgt.filegen_opts, fgn);
 		}
-#line 2730 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2714 "ntp_parser.c"
     break;
 
   case 103: /* stats_list: stats_list stat  */
-#line 724 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 726 "../../ntpd/ntp_parser.y"
                 {
 			(yyval.Int_fifo) = (yyvsp[-1].Int_fifo);
 			APPEND_G_FIFO((yyval.Int_fifo), create_int_node((yyvsp[0].Integer)));
 		}
-#line 2739 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2723 "ntp_parser.c"
     break;
 
   case 104: /* stats_list: stat  */
-#line 729 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 731 "../../ntpd/ntp_parser.y"
                 {
 			(yyval.Int_fifo) = NULL;
 			APPEND_G_FIFO((yyval.Int_fifo), create_int_node((yyvsp[0].Integer)));
 		}
-#line 2748 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2732 "ntp_parser.c"
     break;
 
   case 113: /* filegen_option_list: %empty  */
-#line 748 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 750 "../../ntpd/ntp_parser.y"
                         { (yyval.Attr_val_fifo) = NULL; }
-#line 2754 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2738 "ntp_parser.c"
     break;
 
   case 114: /* filegen_option_list: filegen_option_list filegen_option  */
-#line 750 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 752 "../../ntpd/ntp_parser.y"
                 {
 			(yyval.Attr_val_fifo) = (yyvsp[-1].Attr_val_fifo);
 			APPEND_G_FIFO((yyval.Attr_val_fifo), (yyvsp[0].Attr_val));
 		}
-#line 2763 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2747 "ntp_parser.c"
     break;
 
   case 115: /* filegen_option: T_File T_String  */
-#line 758 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 760 "../../ntpd/ntp_parser.y"
                 {
 			if (lex_from_file()) {
 				(yyval.Attr_val) = create_attr_sval((yyvsp[-1].Integer), (yyvsp[0].String));
@@ -2773,11 +2757,11 @@ yyparse (void)
 				yyerror("filegen file remote config ignored");
 			}
 		}
-#line 2777 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2761 "ntp_parser.c"
     break;
 
   case 116: /* filegen_option: T_Type filegen_type  */
-#line 768 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 770 "../../ntpd/ntp_parser.y"
                 {
 			if (lex_from_file()) {
 				(yyval.Attr_val) = create_attr_ival((yyvsp[-1].Integer), (yyvsp[0].Integer));
@@ -2786,11 +2770,11 @@ yyparse (void)
 				yyerror("filegen type remote config ignored");
 			}
 		}
-#line 2790 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2774 "ntp_parser.c"
     break;
 
   case 117: /* filegen_option: link_nolink  */
-#line 777 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 779 "../../ntpd/ntp_parser.y"
                 {
 			const char *err;
 
@@ -2805,69 +2789,59 @@ yyparse (void)
 				yyerror(err);
 			}
 		}
-#line 2809 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2793 "ntp_parser.c"
     break;
 
   case 118: /* filegen_option: enable_disable  */
-#line 792 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 794 "../../ntpd/ntp_parser.y"
                         { (yyval.Attr_val) = create_attr_ival(T_Flag, (yyvsp[0].Integer)); }
-#line 2815 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2799 "ntp_parser.c"
     break;
 
   case 130: /* access_control_command: T_Discard discard_option_list  */
-#line 822 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 824 "../../ntpd/ntp_parser.y"
                 {
 			CONCAT_G_FIFOS(cfgt.discard_opts, (yyvsp[0].Attr_val_fifo));
 		}
-#line 2823 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2807 "ntp_parser.c"
     break;
 
   case 131: /* access_control_command: T_Mru mru_option_list  */
-#line 826 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+#line 828 "../../ntpd/ntp_parser.y"
                 {
 			CONCAT_G_FIFOS(cfgt.mru_opts, (yyvsp[0].Attr_val_fifo));
 		}
-#line 2831 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
-    break;
-
-  case 132: /* access_control_command: T_Restrict address res_ippeerlimit ac_flag_list  */
-#line 830 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
-                {
-			restrict_node *rn;
-
-			rn = create_restrict_node((yyvsp[-2].Address_node), NULL, (yyvsp[-1].Integer), (yyvsp[0].Attr_val_fifo),
-						  lex_current()->curpos.nline);
-			APPEND_G_FIFO(cfgt.restrict_opts, rn);
-		}
-#line 2843 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2815 "ntp_parser.c"
     break;
 
-  case 133: /* access_control_command: T_Restrict address T_Mask ip_address res_ippeerlimit ac_flag_list  */
-#line 838 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+  case 132: /* access_control_command: T_Restrict address restrict_mask res_ippeerlimit ac_flag_list  */
+#line 832 "../../ntpd/ntp_parser.y"
                 {
 			restrict_node *rn;
 
-			rn = create_restrict_node((yyvsp[-4].Address_node), (yyvsp[-2].Address_node), (yyvsp[-1].Integer), (yyvsp[0].Attr_val_fifo),
-						  lex_current()->curpos.nline);
+			rn = create_restrict_node((yyvsp[-3].Address_node), (yyvsp[-2].Address_node), (yyvsp[-1].Integer), (yyvsp[0].Attr_val_fifo), FALSE,
+						  lex_current()->curpos.nline,
+						  lex_current()->curpos.ncol);
 			APPEND_G_FIFO(cfgt.restrict_opts, rn);
 		}
-#line 2855 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2828 "ntp_parser.c"
     break;
 
-  case 134: /* access_control_command: T_Restrict T_Default res_ippeerlimit ac_flag_list  */
-#line 846 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+  case 133: /* access_control_command: T_Restrict T_Default res_ippeerlimit ac_flag_list  */
+#line 841 "../../ntpd/ntp_parser.y"
                 {
 			restrict_node *rn;
 
-			rn = create_restrict_node(NULL, NULL, (yyvsp[-1].Integer), (yyvsp[0].Attr_val_fifo),
-						  lex_current()->curpos.nline);
+			rn = create_restrict_node(NULL, NULL, (yyvsp[-1].Integer), (yyvsp[0].Attr_val_fifo), FALSE,
+						  lex_current()->curpos.nline,
+						  lex_current()->curpos.ncol);
 			APPEND_G_FIFO(cfgt.restrict_opts, rn);
 		}
-#line 2867 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2841 "ntp_parser.c"
     break;
 
-  case 135: /* access_control_command: T_Restrict T_Ipv4_flag T_Default res_ippeerlimit ac_flag_list  */
-#line 854 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+  case 134: /* access_control_command: T_Restrict T_Ipv4_flag T_Default res_ippeerlimit ac_flag_list  */
+#line 850 "../../ntpd/ntp_parser.y"
                 {
 			restrict_node *rn;
 
@@ -2878,15 +2852,16 @@ yyparse (void)
 				create_address_node(
 					estrdup("0.0.0.0"),
 					AF_INET),
-				(yyvsp[-1].Integer), (yyvsp[0].Attr_val_fifo),
-				lex_current()->curpos.nline);
+				(yyvsp[-1].Integer), (yyvsp[0].Attr_val_fifo), FALSE,
+				lex_current()->curpos.nline,
+				lex_current()->curpos.ncol);
 			APPEND_G_FIFO(cfgt.restrict_opts, rn);
 		}
-#line 2886 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2861 "ntp_parser.c"
     break;
 
-  case 136: /* access_control_command: T_Restrict T_Ipv6_flag T_Default res_ippeerlimit ac_flag_list  */
-#line 869 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+  case 135: /* access_control_command: T_Restrict T_Ipv6_flag T_Default res_ippeerlimit ac_flag_list  */
+#line 866 "../../ntpd/ntp_parser.y"
                 {
 			restrict_node *rn;
 
@@ -2897,34 +2872,79 @@ yyparse (void)
 				create_address_node(
 					estrdup("::"),
 					AF_INET6),
-				(yyvsp[-1].Integer), (yyvsp[0].Attr_val_fifo),
-				lex_current()->curpos.nline);
+				(yyvsp[-1].Integer), (yyvsp[0].Attr_val_fifo), FALSE,
+				lex_current()->curpos.nline,
+				lex_current()->curpos.ncol);
 			APPEND_G_FIFO(cfgt.restrict_opts, rn);
 		}
-#line 2905 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2881 "ntp_parser.c"
     break;
 
-  case 137: /* access_control_command: T_Restrict T_Source res_ippeerlimit ac_flag_list  */
-#line 884 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+  case 136: /* access_control_command: T_Restrict T_Source res_ippeerlimit ac_flag_list  */
+#line 882 "../../ntpd/ntp_parser.y"
                 {
 			restrict_node *	rn;
 
 			APPEND_G_FIFO((yyvsp[0].Attr_val_fifo), create_attr_ival((yyvsp[-2].Integer), 1));
-			rn = create_restrict_node(
-				NULL, NULL, (yyvsp[-1].Integer), (yyvsp[0].Attr_val_fifo), lex_current()->curpos.nline);
+			rn = create_restrict_node(NULL, NULL, (yyvsp[-1].Integer), (yyvsp[0].Attr_val_fifo), FALSE,
+						  lex_current()->curpos.nline,
+						  lex_current()->curpos.ncol);
 			APPEND_G_FIFO(cfgt.restrict_opts, rn);
 		}
-#line 2918 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2895 "ntp_parser.c"
     break;
 
-  case 138: /* res_ippeerlimit: %empty  */
-#line 896 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+  case 137: /* access_control_command: T_Delrestrict ip_address restrict_mask  */
+#line 892 "../../ntpd/ntp_parser.y"
+                {
+			restrict_node *	rn;
+
+			rn = create_restrict_node((yyvsp[-1].Address_node), (yyvsp[0].Address_node), -1, NULL, TRUE,
+						  lex_current()->curpos.nline,
+						  lex_current()->curpos.ncol);
+			APPEND_G_FIFO(cfgt.restrict_opts, rn);
+		}
+#line 2908 "ntp_parser.c"
+    break;
+
+  case 138: /* access_control_command: T_Delrestrict T_Source ip_address  */
+#line 901 "../../ntpd/ntp_parser.y"
+                {
+			restrict_node *	rn;
+			attr_val_fifo * avf;
+
+			avf = NULL;
+			APPEND_G_FIFO(avf, create_attr_ival((yyvsp[-1].Integer), 1));
+			rn = create_restrict_node((yyvsp[0].Address_node), NULL, -1, avf, TRUE,
+						  lex_current()->curpos.nline,
+						  lex_current()->curpos.ncol);
+			APPEND_G_FIFO(cfgt.restrict_opts, rn);
+		}
+#line 2924 "ntp_parser.c"
+    break;
+
+  case 139: /* restrict_mask: %empty  */
+#line 916 "../../ntpd/ntp_parser.y"
+                        { (yyval.Address_node) = NULL; }
+#line 2930 "ntp_parser.c"
+    break;
+
+  case 140: /* restrict_mask: T_Mask ip_address  */
+#line 918 "../../ntpd/ntp_parser.y"
+                {
+			(yyval.Address_node) = (yyvsp[0].Address_node);
+		}
+#line 2938 "ntp_parser.c"
+    break;
+
+  case 141: /* res_ippeerlimit: %empty  */
+#line 925 "../../ntpd/ntp_parser.y"
                         { (yyval.Integer) = -1; }
-#line 2924 "../../../src/ntp-stable-3758/ntpd/ntp_parser.c"
+#line 2944 "ntp_parser.c"
     break;
 
-  case 139: /* res_ippeerlimit: T_Ippeerlimit T_Integer  */
-#line 898 "../../../src/ntp-stable-3758/ntpd/ntp_parser.y"
+  case 142: /* res_ippeerlimit: T_Ippeerlimit T_Integer  */
+#line 927 "../../ntpd/ntp_parser.y"
                 {
 			if (((yyvsp[0].Integer) < -1) || ((yyvsp[0].Integer) > 100)) {
 				struct FILE_INFO * ip_ctx;
